	rollout SCNExport "Scn Exporter"
	(
		local ostream, tabs = ""
	
		group "Options"
		(
			checkbox cb_exportSelOnly "Export Selected Only"
		)
	
		button btn_export "Save As..." width:100
	
	
		-------------------------------------------------------------------------------------
		function ExportMesh meshObj =
		(
	
			Format ("\n") 
			Format ("//-------------------------------------------------\n")  
			Format ("// %\n") meshObj.name 
			Format ("//-------------------------------------------------\n") 
			
		
			varname= meshObj.name
			for i = 1 to varname.count do
				if varname[i] == " " then varname[i] = "_"
			
			bHasMap= false;
			texture= "none";
			if (meshObj.material!=undefined) then
			(
				if ((meshObj.material.mapEnables[2]) and (meshObj.material.maps[2]!=undefined)) then
				(
					texture= filenameFromPath meshObj.material.maps[2].filename
-- getFilenameFile meshObj.material.maps[2].filename;
					bHasMap= true;
				)
				
			)
			else
			(
--				Format ("Diffuse: % % %\n") meshObj.wireColor.r meshObj.wireColor.b meshObj.wireColor.g 
--				Format ("Map: none\n")  
			)				
			update meshObj true true true
			if (meshObj.numFaces) > 0 then
			(
				if (bHasMap==true) then
				(
				for i = 1 to (meshObj.numFaces) do
				(
						 
					vrt= (GetVert meshObj (GetFace meshObj i).x )
					vrt2= (GetVert meshObj (GetFace meshObj i).y )
					vrt3= (GetVert meshObj (GetFace meshObj i).z )
					
--					(Format "% % % \n" vrt vrt2 vrt3)
					if (vrt!=vrt2 and vrt!=vrt3 and vrt2!=vrt3) then
					(
			maxdist= (getUserProp meshObj "MaxDistance")
			if (maxdist==undefined) then
				maxdist= -1                       
			mindist= (getUserProp meshObj "MinDistance")
			if (mindist==undefined) then
				mindist= 0					
					Format ("node % % none triangles material ambient: % % % ") maxdist mindist meshObj.material.ambient.r meshObj.material.ambient.g meshObj.material.ambient.b 
					Format ("diffuse: % % % ") meshObj.material.diffuse.r meshObj.material.diffuse.g meshObj.material.diffuse.b 
					Format ("specular: % % % ") meshObj.material.specular.r meshObj.material.specular.g meshObj.material.specular.b 
					Format (" endmaterial %\n") texture 
--					tu= (GetTVert meshObj (GetTVFace meshObj i).x ).x;
--					tv= (GetTVert meshObj (GetTVFace meshObj i).x ).y;


					
					Format ("% ") (-vrt.x) 
					Format ("% ") (vrt.z) 
					Format ("% 	") (vrt.y) 
			norm= getNormal meshObj (GetFace meshObj i).x
					Format ("% ") (-norm.x) 
					Format ("% ") (norm.z) 
					Format ("%  ") (norm.y) 
--					Format ("0.0 ")  
--					Format ("0.0 ")  
					Format ("% ") ((GetTVert meshObj (GetTVFace meshObj i).x ).x) 
					Format ("% ") ((GetTVert meshObj (GetTVFace meshObj i).x ).y) 
					Format ("end\n") 
					
					vrt= vrt2
					Format ("% ") (-vrt.x) 
					Format ("% ") (vrt.z) 
					Format ("% 	") (vrt.y) 
			norm= getNormal meshObj (GetFace meshObj i).y
					Format ("% ") (-norm.x) 
					Format ("% ") (norm.z)
					Format ("%  ") (norm.y)
--					Format ("% ") ((GetTVert meshObj (GetTVFace meshObj i).y ).x-tu) 
--					Format ("% ") ((GetTVert meshObj (GetTVFace meshObj i).y ).y-tv) 
					Format ("% ") ((GetTVert meshObj (GetTVFace meshObj i).y ).x) 
					Format ("% ") ((GetTVert meshObj (GetTVFace meshObj i).y ).y) 
					Format ("end\n") 
					
					vrt= vrt3
					Format ("% ") (-vrt.x) 
					Format ("% ") (vrt.z) 
					Format ("% 	") (vrt.y) 
			norm= getNormal meshObj (GetFace meshObj i).z
					Format ("% ") (-norm.x) 
					Format ("% ") (norm.z) 
					Format ("%  ") (norm.y) 
--					Format ("% ") ((GetTVert meshObj (GetTVFace meshObj i).z ).x-tu) 
--					Format ("% \n") ((GetTVert meshObj (GetTVFace meshObj i).z ).y-tv) 
					Format ("% ") ((GetTVert meshObj (GetTVFace meshObj i).z ).x) 
					Format ("% \n") ((GetTVert meshObj (GetTVFace meshObj i).z ).y) 
					Format ("endtri\n") 
					Format ("\n") 
					)
					else
						(Format "//Degenerated triangle!")
				)	
				)
			)
			
		)
	
		-------------------------------------------------------------------------------------
		function ExportSpline splObj =
		(
		
--			convertToSplineShape splObj;
			
--			return true;
			bError= false
		
			varname= splObj.name
			for i = 1 to varname.count do
				if varname[i] == " " then varname[i] = "_"
				
			mindist= "0"
prop= (getUserProp splObj "MinDistance")
if (prop!=undefined) then
 mindist= prop
maxdist= "-1"
prop= (getUserProp splObj "MaxDistance")
if (prop!=undefined) then
 maxdist= prop
			case (getUserProp splObj "Type") of
			(
				"normal":
				(
					if ((numSplines splObj)==1) and ((numKnots splObj 1)==2) then
					(
--						Format ("node -1 0 % track normal % % % % % \n") varname (getUserProp splObj "Texture1") (getUserProp splObj "Texture2") (getUserProp splObj "Category") (getUserProp splObj "Width") (getUserProp splObj "Sound") (getUserProp splObj "Quality") (getUserProp splObj "Damage") (getUserProp splObj "Visibility")  
     						evis= (getUserProp splObj "Visibility")
					        if (evis=="vis") then
                                                 (
						   Format ("node % % % track normal % % % % % % % % \n % % % % % % \n") maxdist mindist varname  (getUserProp splObj "Length") (getUserProp splObj "TrackWidth") (getUserProp splObj "Friction") (getUserProp splObj "SoundDist") (getUserProp splObj "Quality") (getUserProp splObj "DamageFlag") (getUserProp splObj "Environment") (getUserProp splObj "Visibility") (getUserProp splObj "Tex1") (getUserProp splObj "TexLength") (getUserProp splObj "Tex2") (getUserProp splObj "TexPar1") (getUserProp splObj "TexPar2") (getUserProp splObj "TexPar3") 
						 )
						else
                                                 (
						   Format ("node % % % track normal % % % % % % % % \n") maxdist mindist varname  (getUserProp splObj "Length") (getUserProp splObj "TrackWidth") (getUserProp splObj "Friction") (getUserProp splObj "SoundDist") (getUserProp splObj "Quality") (getUserProp splObj "DamageFlag") (getUserProp splObj "Environment") (getUserProp splObj "Visibility") 
						 )
 							
						pt= getKnotPoint splObj 1 1
						Format ("% ") (-pt.x) 
						Format ("% ") (pt.z) 
						Format ("%  %  //point 1\n") (pt.y) (getUserProp splObj "Roll1") 
					
						if ((getSegmentType splObj 1 1)==#curve) then
						(
							pt= (getOutVec splObj 1 1) - (getKnotPoint splObj 1 1)
							Format ("% ") (-pt.x) 
							Format ("% ") (pt.z) 
							Format ("%  //control vector 1\n") (pt.y) 

							pt= (getInVec splObj 1 2) - (getKnotPoint splObj 1 2)
							Format ("% ") (-pt.x) 
							Format ("% ") (pt.z) 
							Format ("%  //control vector 2\n") (pt.y)
						)
						else
						(
							Format ("0.0 0.0 0.0  //control vector 1\n") 
							Format ("0.0 0.0 0.0  //control vector 2\n") 
						)

						pt= getKnotPoint splObj 1 2
						Format ("% ") (-pt.x) 
						Format ("% ") (pt.z) 
						Format ("%  %  //point 2\n") (pt.y) (getUserProp splObj "Roll2") 
						Format ("% \n") (getUserProp splObj "Radius1") 						
					)
					else
					(
						messageBox "Track export error: " + varname
					)
				)
				"switch":
				(
					if ((numSplines splObj)==2) and ((numKnots splObj 1)==2) and ((numKnots splObj 2)==2) then
					(
--						Format ("node -1 0 % track switch % % % % % % \n % \n") varname (getUserProp splObj "Texture1") (getUserProp splObj "Texture2") (getUserProp splObj "Category") (getUserProp splObj "Width") (getUserProp splObj "Sound") (getUserProp splObj "Quality") (getUserProp splObj "DamageFlag") (getUserProp splObj "Visibility") (getUserProp splObj "State") 
--						Format ("node % % % track switch % % % % % % % % % % % % % % \n") (getUserProp splObj "MaxDistance") (getUserProp splObj "MinDistance") varname  (getUserProp splObj "Length") (getUserProp splObj "TrackWidth") (getUserProp splObj "Friction") (getUserProp splObj "SoundDist") (getUserProp splObj "Quality") (getUserProp splObj "DamageFlag") (getUserProp splObj "Environment") (getUserProp splObj "Visibility") (getUserProp splObj "Tex1") (getUserProp splObj "TexLength") (getUserProp splObj "Tex2") (getUserProp splObj "TexPar1") (getUserProp splObj "TexPar2") (getUserProp splObj "TexPar3") 
     						evis= (getUserProp splObj "Visibility")
					        if (evis=="vis") then
                                                 (
						   Format ("node % % % track switch % % % % % % % % \n % % % % % % \n") maxdist mindist varname  (getUserProp splObj "Length") (getUserProp splObj "TrackWidth") (getUserProp splObj "Friction") (getUserProp splObj "SoundDist") (getUserProp splObj "Quality") (getUserProp splObj "DamageFlag") (getUserProp splObj "Environment") (getUserProp splObj "Visibility") (getUserProp splObj "Tex1") (getUserProp splObj "TexLength") (getUserProp splObj "Tex2") (getUserProp splObj "TexPar1") (getUserProp splObj "TexPar2") (getUserProp splObj "TexPar3") 
						 )
						else
                                                 (
						   Format ("node % % % track switch % % % % % % % % \n") maxdist mindist varname  (getUserProp splObj "Length") (getUserProp splObj "TrackWidth") (getUserProp splObj "Friction") (getUserProp splObj "SoundDist") (getUserProp splObj "Quality") (getUserProp splObj "DamageFlag") (getUserProp splObj "Environment") (getUserProp splObj "Visibility") 
						 )
						pt= getKnotPoint splObj 1 1
						Format ("% ") (-pt.x) 
						Format ("% ") (pt.z) 
						Format ("%  0.1  //point 1\n") (pt.y) 
					
						if ((getSegmentType splObj 1 1)==#curve) then
						(
							pt= (getOutVec splObj 1 1) - (getKnotPoint splObj 1 1)
							Format ("% ") (-pt.x) 
							Format ("% ") (pt.z) 
							Format ("%  //control vector 1\n") (pt.y) 

							pt= (getInVec splObj 1 2) - (getKnotPoint splObj 1 2)
							Format ("% ") (-pt.x) 
							Format ("% ") (pt.z) 
							Format ("%  //control vector 2\n") (pt.y)
						)
						else
						(
							Format ("0.0 0.0 0.0  //control vector 1\n") 
							Format ("0.0 0.0 0.0  //control vector 2\n") 
						)

						pt= getKnotPoint splObj 1 2
						Format ("% ") (-pt.x) 
						Format ("% ") (pt.z) 
						Format ("%  -0.1  //point 2\n") (pt.y) 
						Format ("% \n") (getUserProp splObj "Radius1") 


						pt= getKnotPoint splObj 2 1
						Format ("% ") (-pt.x) 
						Format ("% ") (pt.z) 
						Format ("%  0  //point 1\n") (pt.y)  
					
						if ((getSegmentType splObj 2 1)==#curve) then
						(
							pt= (getOutVec splObj 2 1) - (getKnotPoint splObj 2 1)
							Format ("% ") (-pt.x)  
							Format ("% ") (pt.z)  
							Format ("%  //control vector 1\n") (pt.y)  

							pt= (getInVec splObj 2 2) - (getKnotPoint splObj 2 2)
							Format ("% ") (-pt.x)  
							Format ("% ") (pt.z)  
							Format ("%  //control vector 2\n") (pt.y)  
						)
						else
						(
							Format ("0.0 0.0 0.0  //control vector 1\n")  
							Format ("0.0 0.0 0.0  //control vector 2\n")  
						)

						pt= getKnotPoint splObj 2 2
						Format ("% ") (-pt.x)  
						Format ("% ") (pt.z)  
						Format ("%  0  //point 2\n") (pt.y)  
						Format ("% \n") (getUserProp splObj "Radius2")  			


					
					)
					else
					(
						messageBox "Track export error: " + varname
					)

				)
				"road":
				(
					if ((numSplines splObj)==1) and ((numKnots splObj 1)==2) then
					(
     						evis= (getUserProp splObj "Visibility")
mindist= "0"
prop= (getUserProp splObj "MinDistance")
if (prop!=undefined) then
 mindist= prop
maxdist= "-1"
prop= (getUserProp splObj "MaxDistance")
if (prop!=undefined) then
 maxdist= prop
					        if (evis=="vis") then
                                                 (
						   Format ("node % % % track road % % % % % % % % \n % % % % % % \n") maxdist mindist varname  (getUserProp splObj "Length") (getUserProp splObj "TrackWidth") (getUserProp splObj "Friction") (getUserProp splObj "SoundDist") (getUserProp splObj "Quality") (getUserProp splObj "DamageFlag") (getUserProp splObj "Environment") (getUserProp splObj "Visibility") (getUserProp splObj "Tex1") (getUserProp splObj "TexLength") (getUserProp splObj "Tex2") (getUserProp splObj "TexPar1") (getUserProp splObj "TexPar2") (getUserProp splObj "TexPar3")  
						 )
						else
                                                 (
						   Format ("node % % % track road % % % % % % % % \n") maxdist mindist varname  (getUserProp splObj "Length") (getUserProp splObj "TrackWidth") (getUserProp splObj "Friction") (getUserProp splObj "SoundDist") (getUserProp splObj "Quality") (getUserProp splObj "DamageFlag") (getUserProp splObj "Environment") (getUserProp splObj "Visibility")  
						 )
 							
						pt= getKnotPoint splObj 1 1
						Format ("% ") (-pt.x)  
						Format ("% ") (pt.z)  
						Format ("%  %  //point 1\n") (pt.y) (getUserProp splObj "Roll1")  
					
						if ((getSegmentType splObj 1 1)==#curve) then
						(
							pt= (getOutVec splObj 1 1) - (getKnotPoint splObj 1 1)
							Format ("% ") (-pt.x)  
							Format ("% ") (pt.z)  
							Format ("%  //control vector 1\n") (pt.y)  

							pt= (getInVec splObj 1 2) - (getKnotPoint splObj 1 2)
							Format ("% ") (-pt.x)  
							Format ("% ") (pt.z)  
							Format ("%  //control vector 2\n") (pt.y)  
						)
						else
						(
							Format ("0.0 0.0 0.0  //control vector 1\n")  
							Format ("0.0 0.0 0.0  //control vector 2\n")  
						)

						pt= getKnotPoint splObj 1 2
						Format ("% ") (-pt.x)  
						Format ("% ") (pt.z)  
						Format ("%  %  //point 2\n") (pt.y) (getUserProp splObj "Roll2")  
						Format ("% \n") (getUserProp splObj "Radius1")  						
					)
					else
					(
						messageBox "Road export error: " + varname
					)
				)
				"river":
				(
					if ((numSplines splObj)==1) and ((numKnots splObj 1)==2) then
					(
mindist= "0"
prop= (getUserProp splObj "MinDistance")
if (prop!=undefined) then
 mindist= prop
maxdist= "-1"
prop= (getUserProp splObj "MaxDistance")
if (prop!=undefined) then
 maxdist= prop
     						evis= (getUserProp splObj "Visibility")
					        if (evis=="vis") then
                                                 (
						   Format ("node % % % track river % % % % % % % % \n % % % % % % \n") maxdist mindist varname  (getUserProp splObj "Length") (getUserProp splObj "TrackWidth") (getUserProp splObj "Friction") (getUserProp splObj "SoundDist") (getUserProp splObj "Quality") (getUserProp splObj "DamageFlag") (getUserProp splObj "Environment") (getUserProp splObj "Visibility") (getUserProp splObj "Tex1") (getUserProp splObj "TexLength") (getUserProp splObj "Tex2") (getUserProp splObj "TexPar1") (getUserProp splObj "TexPar2") (getUserProp splObj "TexPar3")  
						 )
						else
                                                 (
						   Format ("node % % % track river % % % % % % % % \n") maxdist mindist varname  (getUserProp splObj "Length") (getUserProp splObj "TrackWidth") (getUserProp splObj "Friction") (getUserProp splObj "SoundDist") (getUserProp splObj "Quality") (getUserProp splObj "DamageFlag") (getUserProp splObj "Environment") (getUserProp splObj "Visibility")  
						 )
 							
						pt= getKnotPoint splObj 1 1
						Format ("% ") (-pt.x)  
						Format ("% ") (pt.z)  
						Format ("%  %  //point 1\n") (pt.y) (getUserProp splObj "Roll1")  
					
						if ((getSegmentType splObj 1 1)==#curve) then
						(
							pt= (getOutVec splObj 1 1) - (getKnotPoint splObj 1 1)
							Format ("% ") (-pt.x)  
							Format ("% ") (pt.z)  
							Format ("%  //control vector 1\n") (pt.y)  

							pt= (getInVec splObj 1 2) - (getKnotPoint splObj 1 2)
							Format ("% ") (-pt.x)  
							Format ("% ") (pt.z)  
							Format ("%  //control vector 2\n") (pt.y)  
						)
						else
						(
							Format ("0.0 0.0 0.0  //control vector 1\n")  
							Format ("0.0 0.0 0.0  //control vector 2\n")  
						)

						pt= getKnotPoint splObj 1 2
						Format ("% ") (-pt.x)  
						Format ("% ") (pt.z)  
						Format ("%  %  //point 2\n") (pt.y) (getUserProp splObj "Roll2")  
						Format ("% \n") (getUserProp splObj "Radius1")  						
					)
					else
					(
						messageBox "Road export error: " + varname
					)
				)
				"traction":
				(
					def= ""
					prop= (getUserProp splObj "Default")
					if (prop!=undefined) then
						def= prop
mindist= "0"
prop= (getUserProp splObj "MinDistance")
if (prop!=undefined) then
 mindist= prop

maxdist= "800"
prop= (getUserProp splObj "MaxDistance")
if (prop!=undefined) then
 maxdist= prop


nominalvoltage= "3500"
prop= (getUserProp splObj "nominalvoltage")
if (prop!=undefined) then
 nominalvoltage= prop

maxcurrent= "4500"
prop= (getUserProp splObj "maxcurrent")
if (prop!=undefined) then
 maxcurrent= prop

resistivity= "0.01"
prop= (getUserProp splObj "resistivity")
if (prop!=undefined) then
 resistivity= prop

material= "Cu"
prop= (getUserProp splObj "material")
if (prop!=undefined) then
 material= prop

wirethickness= "3"
prop= (getUserProp splObj "wirethickness")
if (prop!=undefined) then
 wirethickness= prop

damageflag= "1"
prop= (getUserProp splObj "damageflag")
if (prop!=undefined) then
 damageflag= prop

h1= 1.7
prop= (getUserProp splObj "h1")
if (prop!=undefined) then
 h1= prop

h2= 1.7
prop= (getUserProp splObj "h2")
if (prop!=undefined) then
 h2= prop

hmin= "0.4"
prop= (getUserProp splObj "hmin")
if (prop!=undefined) then
 hmin= prop

deltal= "4.0"
prop= (getUserProp splObj "deltal")
if (prop!=undefined) then
 deltal= prop

wires= "2"
prop= (getUserProp splObj "wires")
if (prop!=undefined) then
 wires= prop

wireoffset= "0.04"
prop= (getUserProp splObj "wireoffset")
if (prop!=undefined) then
 wireoffset= prop

visibility= "vis"
prop= (getUserProp splObj "visibility")
if (prop!=undefined) then
 visibility= prop


					for i=1 to (numKnots splObj 1) do
					(
						kt= getKnotType splObj 1 i
						(
							v1= [0,0,0]
							v2= [0,0,0]
							if (i>1) then
							(
								v1= (getKnotPoint splObj 1 (i-1))-(getKnotPoint splObj 1 i) 
								v1.z=0
								v1= (normalize v1)
								pt2= (getKnotPoint splObj 1 i) 
								pt1= (getKnotPoint splObj 1 (i-1)) 
								Format ("node % %  none traction % % % % % % %\n") maxdist mindist varname nominalvoltage maxcurrent resistivity material wirethickness damageflag  
								Format ("% % %\n% % %\n") -pt1.x pt1.z pt1.y -pt2.x pt2.z pt2.y  
								Format ("% % %\n% % %\n% % % % % \n") -pt1.x (pt1.z+h1) pt1.y -pt2.x (pt2.z+h2) pt2.y hmin deltal wires wireoffset visibility  								
								Format ("endtraction\n")  
							)
								
							if (i<(numKnots splObj 1)) then
							(
								v2= (getKnotPoint splObj 1 i)-(getKnotPoint splObj 1 (i+1)) 
								v2.z=0
								v2= (normalize v2)
							)
							vec= v1+v2
						)

						vec.z= 0
						vec= normalize vec
						Format ("vec % \n") vec
						
						a= (atan2 vec.y vec.x) + 90
						pt= (getKnotPoint splObj 1 i)
						
						def= ""
						prop= (getUserProp splObj (i as string))
						if (prop==undefined) then
							prop= def
						if (prop!="") then
						(
							arr= filterString prop ";"
							Format ("include % % % % % % end\n\n") arr[1] (-pt.x) (pt.z) (pt.y) a arr[2]  
						)
					)
					return true
				)
				"hekt":
				(
					step= 100
					startDistance= 0
					length= (curveLength splObj 1)
					sideDistance= 3.7
					style= 2
					
					prop= (getUserProp splObj "step")
					if (prop!=undefined) then
						step= prop
						
					prop= (getUserProp splObj "startDistance")
					if (prop!=undefined) then
						startDistance= prop
						
					prop= (getUserProp splObj "overrideLength")
					if (prop!=undefined) then
						length= prop
					
					prop= (getUserProp splObj "sideDistance")
					if (prop!=undefined) then
						sideDistance= prop
					
					prop= (getUserProp splObj "style")
					if (prop!=undefined) then
						style= prop as integer
						
			
					s= 0.0
					
					if (style==1) then
					(
						sign= 1
						side= 1
						
					)
					else
					if (style==-1) then
					(
						sign= 1
						side= -1
						
					)
					else
					(
						sign= -1
						side= 1
					)	
					
					while (s<length) do
					(
						km_digits=  (floor ((s + startDistance)/1000)) as integer
						tmp= (((s + startDistance)/1000-km_digits)*10) 
						sm_digits= (floor (tmp+0.5)) as integer

						format "s=% k=% sm=% side=% \n" s km_digits sm_digits side
						
						i= s/(curveLength splObj 1)

						vec= lengthTangent splObj 1 i
						parallel= [vec.y,-vec.x,vec.z]
						pt= (lengthInterp splObj 1 i)+side*(normalize parallel)*sideDistance
						a= (atan2 vec.y vec.x) + 90
						km_str= (km_digits as string)
						sm_str= sm_digits as string
						if (km_digits<10) then
						(
							Format ("include;slupek-waski.inc;%;%;%;%;%;slupek-%.t3d;slupek-%.t3d;end\n") (-pt.x) (pt.z) (pt.y) a (a+180) km_str sm_str  
						)
						else
						if (km_digits<100) then
						(
							Format ("include slupek-sredni.inc % % % % % slupek-%lsr.t3d slupek-%psr.t3d slupek-%.t3d end\n") (-pt.x) (pt.z) (pt.y) a (a+180) km_str[1] km_str[2] sm_str  
						)
						else
						(
							Format ("include slupek-szeroki.inc % % % % % slupek-%lsz.t3d slupek-%.t3d slupek-%psz.t3d slupek-%.t3d end\n") (-pt.x) (pt.z) (pt.y) a (a+180) km_str[1] km_str[2] km_str[3] sm_str  
						)
						
						side= side*sign
						s= s+step
					)
					
						
--						a= (atan2 vec.y vec.x) + 90
--						pt= (getKnotPoint splObj 1 i)
						
					return true
				)
				default: bError= true
			)
			
--			ev= (getUserProp splObj "Event")
--			if (ev!=undefined) then
--			(
--				Format ("event1 % \n") ev  
--				Format ("event2 % \n") ev  
--			)
			ev= (getUserProp splObj "Event0")
			if (ev==undefined) then
			 ev= (getUserProp splObj "event0")
			if (ev!=undefined) then
				Format ("event0 % \n") ev  

			ev= (getUserProp splObj "Event1")
			if (ev==undefined) then
			 ev= (getUserProp splObj "event1")
			if (ev!=undefined) then
				Format ("event1 % \n") ev  

			ev= (getUserProp splObj "Event2")
			if (ev==undefined) then
			 ev= (getUserProp splObj "event2")
			if (ev!=undefined) then
				Format ("event2 % \n") ev  
					
			ev= (getUserProp splObj "Velocity")
			if (ev!=undefined) then
				Format ("velocity % \n") ev  

			if ((getUserProp splObj "Type")!=undefined) then
			(
				Format ("endtrack\n")  
--				Format ("\n")  
			)
			str= (getUserProp splObj "ExportString")
			if (str!=undefined) then
			(
				v1= [0,0,0]
				v1= (getKnotPoint splObj 1 1)-(getKnotPoint splObj 1 2) 
				v1.z=0
				v1= (normalize v1)
				zrot= (atan2 v1.y v1.x) + 90
				Format "// additional:\n"  
				Format str splObj.name (-splObj.pos.x) (splObj.pos.z-0.2) splObj.pos.y zrot  
				Format "\n"  
			)
			if ((getUserProp splObj "Type")!=undefined) then
				Format ("\n")  
		
		)
		
		function ExportDummy dumObj =
		(
			Format ("\n")  
			str= (getUserProp dumObj "ExportString")
			if (str!=undefined) then
			(
				if dumObj.name=="Gantry" then
				 Format str (-dumObj.pos.x) dumObj.pos.z dumObj.pos.y dumObj.rotation.z_rotation  
				else
				 Format str dumObj.name (-dumObj.pos.x) dumObj.pos.z dumObj.pos.y dumObj.rotation.z_rotation  
				Format "\n"  
			)
			Format ("\n")  
		)
		
		function ExportPoint ptObj =
		(
			Format ("\n")  
			str= (getUserProp ptObj "ExportString")
			if (str!=undefined) then
			(
				Format str ptObj.name (-ptObj.pos.x) ptObj.pos.z ptObj.pos.y ptObj.rotation.z_rotation  
				Format "\n"  
			)
			for i=1 to 20 do
			(
				str= (getUserProp ptObj ("ExportString"+(i as string)))
				if (str!=undefined) then
				(
					Format str ptObj.name (-ptObj.pos.x) ptObj.pos.z ptObj.pos.y ptObj.rotation.z_rotation  
					Format "\n"  
				)
			)
			Format ("\n")  
		)
		-------------------------------------------------------------------------------------
		function ExportNode1 node =
		(
			if ((getUserProp node "ExportLast")!=true) then
			(
--				Format ("Node: % % %\n") (superClassOf node) (classOf node) node.name
				if SuperClassOf node == shape then
					ExportSpline node
				if SuperClassOf node == Helper and ClassOf node == Dummy and not (isGroupHead node) then
					ExportDummy node
				if (SuperClassOf node == GeometryClass) then
				(
					convertToMesh node
					if (ClassOf node == Editable_mesh) then
						ExportMesh node
				)
				if SuperClassOf node == Helper and ClassOf node == Point then
					ExportPoint node
			)
	
				return true
		)
	
		-------------------------------------------------------------------------------------
		function ExportNode2 node =
		(
			if ((getUserProp node "ExportLast")==true) then
			(
--				Format ("Node: % % %\n") (superClassOf node) (classOf node) node.name
				if SuperClassOf node == shape then
					ExportSpline node
				if SuperClassOf node == Helper and ClassOf node == Dummy and not (isGroupHead node) then
					ExportDummy node
				if (SuperClassOf node == GeometryClass) then
				(
					convertToMesh node
					if (ClassOf node == Editable_mesh) then
						ExportMesh node
				)
				if SuperClassOf node == Helper and ClassOf node == Point then
					ExportPoint node
			)
	
			return true
		)
	
		-------------------------------------------------------------------------------------
		function RecursiveExportNode1 node =
		(
			if (ExportNode1 node) == false then
				return false
			for child in node.children do
				RecursiveExportNode1 child
		)
	
		-------------------------------------------------------------------------------------
		function RecursiveExportNode2 node =
		(
			if (ExportNode2 node) == false then
				return false
			for child in node.children do
				RecursiveExportNode2 child
		)
	
		-------------------------------------------------------------------------------------
		function ExportSCN =
		(
			
			if cb_exportSelOnly.checked then
			(
				for node in selection do
					ExportNode1 node
--				Format "FirstInit\n"  
--MC: przydatne przy eksporcie .inc
				for node in selection do
					ExportNode2 node
			)
			else
			(
				clearSelection()
				for node in rootnode.children do
					RecursiveExportNode1 node
				Format "FirstInit\n"  
				for node in rootnode.children do
					RecursiveExportNode2 node
			)
		)
	
		-------------------------------------------------------------------------------------
	
	
		-------------------------------------------------------------------------------------
		on btn_export pressed do
		(
				ExportSCN()
		)
	
	) -- End SCNExport
	
	